import { Injectable } from '@nestjs/common';
import { BaseDataService } from 'src/core/modules/data/service/base-data.service';
import { UserEntity } from '../../domain/entities/user.entity';
import { InjectRepository } from '@nestjs/typeorm';
import { UserModel } from '../models/user.model';
import { CONNECTION_NAME } from 'src/core/strings/constants/base.constants';
import { IsNull, Not, Repository } from 'typeorm';
import { UserLoginModel } from '../models/user-login.model';

@Injectable()
export class UserDataService extends BaseDataService<UserEntity> {
  constructor(
    @InjectRepository(UserModel, CONNECTION_NAME.DEFAULT)
    private repo: Repository<UserModel>,

    @InjectRepository(UserLoginModel, CONNECTION_NAME.DEFAULT)
    private repoLoginUser: Repository<UserLoginModel>,
  ) {
    super(repo);
  }

  async getLoginUserByItem(itemId: string) {
    return this.repoLoginUser.findOne({
      where: { item_id: itemId, user_id: Not(IsNull()) },
    });
  }
}
